var lib = require('../lib')
var assert = require('assert');

var MOCK_REQ = {
  user: {
    permissions: [ 'p1', 'p2', 'p3', 'p4' ]
  }
}

describe('guard', function () {
  var guard;

  beforeEach(function() {
    guard = lib()
  })

  describe('every', function () {
    it('should not pass #1', function (cb) {
      guard.every([ 'p5' ])(MOCK_REQ, null, function(err) {
        assert(err instanceof Error);
        cb();
      });
    });

    it('should not pass #2', function (cb) {
      guard.every([ 'p1', 'p5' ])(MOCK_REQ, null, function(err) {
        assert(err instanceof Error);
        cb();
      });
    });

    it('should pass', function (cb) {
      guard.every([ 'p1', 'p2' ])(MOCK_REQ, null, function(err) {
        assert(!err);
        cb();
      });
    });
  });

  describe('some', function () {
    it('should not pass #1', function (cb) {
      guard.some([ 'p5' ])(MOCK_REQ, null, function(err) {
        assert(err instanceof Error);
        cb();
      });
    });

    it('should not pass #2', function (cb) {
      guard.some([ 'p5' ])(MOCK_REQ, null, function(err) {
        assert(err instanceof Error);
        cb();
      });
    });

    it('should pass #1', function (cb) {
      guard.some([ 'p1', 'p2' ])(MOCK_REQ, null, function(err) {
        assert(!err);
        cb();
      });
    });

    it('should pass #2', function (cb) {
      guard.some([ 'p1', 'p5' ])(MOCK_REQ, null, function(err) {
        assert(!err);
        cb();
      });
    });
  });
});
